
function RR_AddonMessageReceived(String,Channel)


	Seperator = "\a" -- "\226\149\145"
	Version,mob_guid,player_name,mob_name,LootNumber,ItemLink,rarity,lootIcon,_ = strsplit(Seperator, String,9)
	
	RR_Test("-----Item Received Breakdown-----")
	RR_Test(Version)
	RR_Test(mob_guid)
	RR_Test(player_name)
	RR_Test(mob_name)
	RR_Test(LootNumber)
	RR_Test(ItemLink)
	RR_Test(rarity)
	RR_Test(lootIcon)
	RR_Test(Channel)
	
	-- If the time record is empty
	if RR_LastLootMessageTime == nil then
		RR_LastLootMessageTime = GetTime()	-- Set it to be more than a minute since the last message was received
		--RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"] + 1
		--RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
	end
	
	if RaidRoll_DB["debug"] == true then 
		RR_Test("---Addon Message Times---")
		RR_Test(RR_LastLootMessageTime)
		RR_Test(GetTime())		
		RR_Test(GetTime()-RR_LastLootMessageTime)		
	end
	
	TotalWindows = RaidRoll_DB["Loot"]["TOTAL WINDOWS"] 
	CurrentWindow = RaidRoll_DB["Loot"]["CURRENT WINDOW"] 
	
	if RaidRoll_DB["Loot"][TotalWindows] == nil then
		RaidRoll_DB["Loot"][TotalWindows] = {}
	end
	
	
	if GetTime() > (RR_LastLootMessageTime + 60) then
		-- If the message is received in more than 60 seconds of the last one then create a new window
		RR_LastLootMessageTime = GetTime()
	else
		-- If the message is received in less than 60 seconds of the last one then scan the list for the item and add it to the list if its not already there
		RaidRoll_DB["Loot"][TotalWindows]["LOOTER NAME"]  	= player_name
		RaidRoll_DB["Loot"][TotalWindows]["MOB NAME"] 		= mob_name
		RaidRoll_DB["Loot"][TotalWindows]["TOTAL ITEMS"]  	= LootNumber
		
		if RaidRoll_DB["Loot"][TotalWindows]["ITEM_" .. LootNumber] == nil then
			RaidRoll_DB["Loot"][TotalWindows]["ITEM_" .. LootNumber] = {}
		end
		
		RaidRoll_DB["Loot"][TotalWindows]["ITEM_" .. LootNumber]["ITEMLINK"] 	= ItemLink
		RaidRoll_DB["Loot"][TotalWindows]["ITEM_" .. LootNumber]["ICON"]		= lootIcon
		RaidRoll_DB["Loot"][TotalWindows]["ITEM_" .. LootNumber]["WINNER"]		= "-"
		RaidRoll_DB["Loot"][TotalWindows]["ITEM_" .. LootNumber]["RECEIVED"]	= "-"
		
	end
	
			--	RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"]
				
				
			--					RaidRoll_DB["Loot"][mob_guid]["LOOTER NAME"] 	= player_name
			--					RaidRoll_DB["Loot"][mob_guid]["MOB NAME"] 		= mob_name
			--					RaidRoll_DB["Loot"][mob_guid]["TOTAL ITEMS"] 	= LootNumber
								
								
			--					if RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] == nil then RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] = {} end
								
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ITEMLINK"] 	= ItemLink
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ICON"]		= lootIcon
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["WINNER"]		= "-"
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["RECEIVED"]	= "-"
			
			
			-- 		if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == nil then RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = 0 end
			--		if RaidRoll_DB["Loot"]["CURRENT WINDOW"] == nil then RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 0 end

	RR_Loot_Display_Refresh()
end


function RR_LootWindowEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6 = ...;

	if event == "CHAT_MSG_ADDON" then
		if arg1 == "RRL" then
			if RaidRoll_DB["debug"] == true then 
				RR_Test("---Addon messages---")
				RR_Test(event)
				RR_Test(arg1)
				RR_Test(arg2)
				RR_Test(arg3)
				RR_Test(arg4)
				RR_Test(arg5)
				RR_Test(arg6)
			end
			
			RR_AddonMessageReceived(arg2,arg3)
		end
	end

	
	if event == "LOOT_OPENED" then
		if RaidRoll_DB["debug"] == true then 
			RR_Test(event)
			RR_Test(arg1)
			RR_Test(arg2)
		end
		
		player_name = UnitName("player"); 
		mob_name = UnitName("target"); 
		mob_guid = UnitGUID("target");
		
		if mob_guid == nil then mob_guid = "0xF1008F32001790BE" end
		
		
	-- Check if we are looking at a mob
		if mob_guid ~= nil then
		
		-- Breakdown the guid to see if its an npc
			local B = tonumber(mob_guid:sub(5,5), 16);
			local maskedB = B % 8; -- x % 8 has the same effect as x & 0x7 on numbers <= 0xf
			local knownTypes = {[0]="player", [3]="NPC", [4]="pet", [5]="vehicle"};
			if knownTypes[maskedB] ~= nil then 
				Type = knownTypes[maskedB]
			else
				Type = "unknown entity!"
			end
			RR_Test("Your target is a " .. Type);
			
			if Type ~= "NPC" then mob_name = "Unknown" end
			
	--		if RaidRoll_DB["debug"] == true then RR_Test(mob_name.." has the GUID: "..mob_guid); end
			
		-- Create an array for the mob GUID
	--		if RaidRoll_DB["Loot"][mob_guid] == nil then RaidRoll_DB["Loot"][mob_guid] = {} end
			
			
	--		if RaidRoll_DB["Loot"][mob_guid]["ALREADY FOUND"] == nil then
				
			-- Set it so that we know the mob has been found
	--			RaidRoll_DB["Loot"][mob_guid]["ALREADY FOUND"] = true
	--			if RaidRoll_DB["debug"] == true then RR_Test("New Mob Found!") end
				
			-- Get the number of items on the body
				numLootItems = GetNumLootItems();
				
				LootNumber = 0
				
			-- Check if the mob has loots
				if numLootItems ~= nil then
					if RaidRoll_DB["debug"] == true then RR_Test("The Mob Has Loots!") end
					if RaidRoll_DB["debug"] == true then RR_Test(numLootItems .. " items found") end
					
				-- Used later to see if an item was found yet
					WeHaveFoundAnItem = false
					
				-- Start scanning for items
					for i=1,numLootItems do
					-- If its an item
						if LootSlotIsItem(i) then
							if WeHaveFoundAnItem == false then
							-- If we are currently looking at the last window
		--						if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == RaidRoll_DB["Loot"]["CURRENT WINDOW"] then
								--then increment the current window ID
		--							RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
		--						end
								
							-- Add a window to the list of windows
		--						RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"] + 1
		--						Max_LootID = RaidRoll_DB["Loot"]["TOTAL WINDOWS"]
								
								
							-- Set the Identifier to the mob guid
		--						if RaidRoll_DB["Loot"][Max_LootID] == nil then RaidRoll_DB["Loot"][Max_LootID] = mob_guid end
								
								WeHaveFoundAnItem = true
							end
							
							--for j=1,10 do
								
							-- Increase the count by 1 (because an item was found)
								LootNumber = LootNumber + 1
								
							-- Get the ICON and ITEMLINK
								lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo(i);
								ItemLink = GetLootSlotLink(i); 
								
							-- Create an array
								if RR_Check_ItemLink == nil then RR_Check_ItemLink = {} end
								
								RR_Check_ItemLink[LootNumber] = ItemLink
								LootCount = 0
								RR_Temp_ItemLink = ItemLink
								
								if LootNumber > 1 then
									for i = 1,LootNumber-1 do
									-- Check if the itemlink is the same as one in the list
										if ItemLink == RR_Check_ItemLink[i] then
											LootCount = LootCount + 1
											ItemLink = RR_Temp_ItemLink .. LootCount
											RR_Check_ItemLink[LootNumber] = ItemLink
										end
									end
								end
								
								
						--		local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(ItemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
								
								--if RaidRoll_DB["debug"] == true then RR_Test("Item ID = " .. Id) end
								
								Seperator = "\a" -- "\226\149\145"
								Version = "Beta"
								
								
								
								String = (
											Version .. Seperator .. 
											mob_guid .. Seperator .. 
											player_name .. Seperator .. 
											mob_name .. Seperator .. 
											LootNumber .. Seperator .. 
											ItemLink .. Seperator ..
											rarity .. Seperator ..
											lootIcon
										)
								
								SendAddonMessage( "RRL", 
														String 	--.. Seperator .. strlen(String)
												,"RAID" );
								
			--					RaidRoll_DB["Loot"][mob_guid]["LOOTER NAME"] 	= player_name
			--					RaidRoll_DB["Loot"][mob_guid]["MOB NAME"] 		= mob_name
			--					RaidRoll_DB["Loot"][mob_guid]["TOTAL ITEMS"] 	= LootNumber
								
								
			--					if RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] == nil then RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] = {} end
								
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ITEMLINK"] 	= ItemLink
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ICON"]		= lootIcon
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["WINNER"]		= "-"
			--					RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["RECEIVED"]	= "-"
							--end
							
							
							if RaidRoll_DB["debug"] == true then 
								RR_Test(ItemLink)
								RR_Test(lootIcon)
								RR_Test(lootName)
								RR_Test(lootQuantity)
								RR_Test(rarity)	
							end
							
							RR_Loot_Display_Refresh()						
						end
					end
				--end	
			end
		end
	end
end


-- sets up the loot frame
function RR_SetupLootFrame()

--Clear the database (debugging)
--RaidRoll_DB["Loot"] = {}

if RaidRoll_DB["Loot"] == nil then RaidRoll_DB["Loot"] = {} end
if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == nil then RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = 1 end
if RaidRoll_DB["Loot"]["CURRENT WINDOW"] == nil then RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 1 end





-- Hook Looting events
 local RR_LootEventHook = CreateFrame("Frame")
 
  RR_LootEventHook:RegisterEvent("LOOT_OPENED")
  RR_LootEventHook:RegisterEvent("CHAT_MSG_ADDON")
  
  
 RR_LootEventHook:SetScript("OnEvent", RR_LootWindowEvent)
  
  
  
  

--RR_LOOT_FRAME = CreateFrame("Frame","RR_LOOT_FRAME",UIParent)

rr_default_backdrop = {
  --bgFile="Interface\DialogFrame\UI-DialogBox-Background",  -- path to the background texture
  --edgeFile="Interface\DialogFrame\UI-DialogBox-Border",  -- path to the border texture
  
	--bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
  
  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
    left = 2,
    right = 2,
    top = 2,
    bottom = 2
  }
}

RR_LOOT_FRAME:SetBackdrop(rr_default_backdrop)

-- purple
RR_LOOT_FRAME:SetBackdropColor(1,0,1,1);




RR_LOOT_FRAME:SetFrameStrata("MEDIUM")
RR_LOOT_FRAME:SetWidth(260) -- Set these to whatever height/width is needed 
RR_LOOT_FRAME:SetHeight(270) -- Set these to whatever height/width is needed 
	

--RR_LOOT_FRAME:ClearAllPoints(); 
--RR_LOOT_FRAME:SetPoint("CENTER")


-- Debugging, auto-show the loot window
	if RaidRoll_DB["debug"] == true then RR_LOOT_FRAME:Show() end

RR_LOOT_FRAME:SetMovable(true)
RR_LOOT_FRAME:EnableMouse(true)
RR_LOOT_FRAME:SetScript("OnMouseDown",function()
  RR_LOOT_FRAME:StartMoving()
end)
RR_LOOT_FRAME:SetScript("OnMouseUp",function()
  RR_LOOT_FRAME:StopMovingOrSizing()
end)

if RaidRoll_DB["debug"] == true then RR_Test("Loot Frame - Loaded") end

if RR_LOOT_FRAME:IsShown() then
	if RaidRoll_DB["debug"] == true then RR_Test("Loot Frame - Shown") end
end





-- Create 5 strings and a header for the guild ranks
	Raid_Roll_Loot=CreateFrame("FRAME","Raid_Roll_Loot",RR_LOOT_FRAME);
	
	RR_Loot_String_WindowName = Raid_Roll_Loot:CreateFontString("Window Name","ARTWORK","GameFontNormal");
	RR_Loot_String_WindowName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -8);
	RR_Loot_String_WindowName:SetJustifyH("LEFT")
	RR_Loot_String_WindowName:SetText("Musou's Loot Tracker")
	
	RR_Loot_String_MobName = Raid_Roll_Loot:CreateFontString("Mob Name","ARTWORK","GameFontNormal");
	RR_Loot_String_MobName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -210);
	RR_Loot_String_MobName:SetJustifyH("LEFT")
	RR_Loot_String_MobName:SetText("Mob Name:")
	
	RR_Loot_String_LooterName = Raid_Roll_Loot:CreateFontString("Looter Name","ARTWORK","GameFontNormal");
	RR_Loot_String_LooterName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -230);
	RR_Loot_String_LooterName:SetJustifyH("LEFT")
	RR_Loot_String_LooterName:SetText("Looter Name:")
	
--------------------THE BUTTONS   [<<] [<]   [>] [>>]--------------------
	RR_Loot_ButtonFirst = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonFirst:SetWidth(40)
	RR_Loot_ButtonFirst:SetHeight(20)
	RR_Loot_ButtonFirst:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 5, 5)
	RR_Loot_ButtonFirst:SetText("<<")
	RR_Loot_ButtonFirst:SetScript("OnClick",function() RR_Loot_GotoWindow("First") end)
	
	RR_Loot_ButtonPrev = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonPrev:SetWidth(40)
	RR_Loot_ButtonPrev:SetHeight(20)
	RR_Loot_ButtonPrev:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 50, 5)
	RR_Loot_ButtonPrev:SetText("<")
	RR_Loot_ButtonPrev:SetScript("OnClick",function() RR_Loot_GotoWindow("Prev") end)
	
	RR_Loot_ButtonNext = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonNext:SetWidth(40)
	RR_Loot_ButtonNext:SetHeight(20)
	RR_Loot_ButtonNext:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 95, 5)
	RR_Loot_ButtonNext:SetText(">")
	RR_Loot_ButtonNext:SetScript("OnClick",function() RR_Loot_GotoWindow("Next") end)
	
	RR_Loot_ButtonLast = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonLast:SetWidth(40)
	RR_Loot_ButtonLast:SetHeight(20)
	RR_Loot_ButtonLast:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 140, 5)
	RR_Loot_ButtonLast:SetText(">>")
	RR_Loot_ButtonLast:SetScript("OnClick",function() RR_Loot_GotoWindow("Last") end)
	
	RR_Loot_ButtonMinMax = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonMinMax:SetWidth(30)
	RR_Loot_ButtonMinMax:SetHeight(20)
	RR_Loot_ButtonMinMax:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 200, 5)
	RR_Loot_ButtonMinMax:SetText("Min")
	RR_Loot_ButtonMinMax:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Min","Bottom") end)
	
--[[
	RR_Loot_ButtonMinMaxTop = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonMinMaxTop:SetWidth(30)
	RR_Loot_ButtonMinMaxTop:SetHeight(20)
	RR_Loot_ButtonMinMaxTop:SetPoint("TopLEFT", RR_LOOT_FRAME, "TopLEFT", 200, -5)
	RR_Loot_ButtonMinMaxTop:SetText("Min")
	RR_Loot_ButtonMinMaxTop:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Min","Top") end)
]]

	
--------------------THE SLIDER BAR--------------------------------

 RaidRoll_Loot_Slider = CreateFrame("Slider", "RaidRoll_Loot_Slider_ID", RR_LOOT_FRAME, "OptionsSliderTemplate")
 RaidRoll_Loot_Slider:SetWidth(10)
 RaidRoll_Loot_Slider:SetHeight(RR_LOOT_FRAME:GetHeight() - 30 )
 RaidRoll_Loot_Slider:SetPoint('TOPRIGHT', -8, -25)
 RaidRoll_Loot_Slider:SetOrientation('VERTICAL')
 

 _G[RaidRoll_Loot_Slider:GetName() .. 'Low']:SetText('');
 _G[RaidRoll_Loot_Slider:GetName() .. 'High']:SetText(''); 
 _G[RaidRoll_Loot_Slider:GetName() .. 'Text']:SetText('');


 
 RaidRoll_Loot_Slider:SetMinMaxValues(1, 1)
 RaidRoll_Loot_Slider:SetValueStep(1)
 RaidRoll_Loot_Slider:SetValue(1)

 RaidRoll_Loot_Slider:Show()
 
 
  RaidRoll_Loot_Slider:SetScript("OnValueChanged",function()
	RaidRoll_Loot_Slider_Window_Scroll(0)
  end)
 
 ----------------------------------------------------
 
 -- This allows scrolling and passes arg1 (the direction of the scrolling [1 or -1] )
RR_LOOT_FRAME:EnableMouseWheel(1)
 RR_LOOT_FRAME:SetScript("OnMouseWheel",function()
  RaidRoll_Loot_Slider_Window_Scroll(arg1)
end)

-------------------------------------------------------------

 Close_Button = CreateFrame("Button", "Close_Button", RR_LOOT_FRAME, "UIPanelCloseButton")
 Close_Button:SetWidth(30)
 Close_Button:SetHeight(30)
 Close_Button:SetPoint("TOPRIGHT", RR_LOOT_FRAME, "TOPRIGHT", -0, -0)

--------------------------------------------------------------------------------------------------------
	
	-- Create frames which will be used for items
	for i=1,4 do
		RR_Loot_Name_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Name_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Name_String_i:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 45, 20 - (i*45));
		RR_Loot_Name_String_i:SetJustifyH("LEFT")
		RR_Loot_Name_String_i:SetWidth(200); 
		RR_Loot_Name_String_i:SetText("Item "..i)
		
		RR_Loot_Won_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Won_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Won_String_i:SetPoint("TOPLEFT",RR_Loot_Name_String_i,"TOPLEFT", 0, -12);
		RR_Loot_Won_String_i:SetJustifyH("LEFT")
		RR_Loot_Won_String_i:SetWidth(200); 
		RR_Loot_Won_String_i:SetText("Won Item: "..i)
		
		RR_Loot_Received_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Received_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Received_String_i:SetPoint("TOPLEFT",RR_Loot_Won_String_i,"TOPLEFT", 0, -12);
		RR_Loot_Received_String_i:SetJustifyH("LEFT")
		RR_Loot_Received_String_i:SetWidth(200); 
		RR_Loot_Received_String_i:SetText("Received: "..i)
		
		RR_LootIcon = CreateFrame("Button","RR_LootIcon"..i,RR_LOOT_FRAME)
		--RR_LootIcon:SetFrameStrata("FULLSCREEN")
		RR_LootIcon:SetWidth(40) -- Set these to whatever height/width is needed 
		RR_LootIcon:SetHeight(40) -- Set these to whatever height/width is needed 
		--RR_LootIcon:ClearAllPoints(); 
		RR_LootIcon:SetPoint("TopLeft", "RR_LOOT_FRAME", "TopLeft", 5, 20 - (i*45))
		RR_LootIcon:SetBackdrop(rr_default_backdrop)
		--RR_LootIcon:Show()
		
		RR_LootIcon:SetScript("OnEnter", function(self) RR_MouseOver(self:GetName())	end)
		RR_LootIcon:SetScript("OnLeave", function() GameTooltip:Hide()	end)
	end	
	
	RR_Loot_CurrentVsMaxWindow = Raid_Roll_Loot:CreateFontString("RR_Loot_CurrentVsMaxWindow_String" ,"ARTWORK","GameFontNormal");
	RR_Loot_CurrentVsMaxWindow:SetPoint("topLEFT",RR_LOOT_FRAME,"topLEFT", 155, -8);
	RR_Loot_CurrentVsMaxWindow:SetJustifyH("LEFT")
	RR_Loot_CurrentVsMaxWindow:SetWidth(60); 
	RR_Loot_CurrentVsMaxWindow:SetText("0/0")

	RR_Loot_Display_Refresh()
end

function RR_Loot_GotoWindow(WhichWindow)

	if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ~= 0 then
		if WhichWindow == "First" then
			RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 1
		elseif WhichWindow == "Prev" then
			if RaidRoll_DB["Loot"]["CURRENT WINDOW"] > 1 then
				RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] - 1
			end
		elseif WhichWindow == "Next" then
			if RaidRoll_DB["Loot"]["CURRENT WINDOW"] < RaidRoll_DB["Loot"]["TOTAL WINDOWS"] then
				RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
			end
		elseif WhichWindow == "Last" then
			RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"]
		end
	end
	RaidRoll_Loot_Slider:SetValue(1)
	
	RR_Loot_Display_Refresh()
	
	if RaidRoll_DB["debug"] == true then 
		if RaidRoll_DB["Loot"]["CURRENT WINDOW"] 	~= nil then RR_Test("Current: " .. RaidRoll_DB["Loot"]["CURRENT WINDOW"]) end
		if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] 	~= nil then RR_Test("Total:   " .. RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ) end
	end
end


-- Come back to this
function RaidRoll_Loot_Slider_Window_Scroll(direction)

	if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ~= 0 then
		-- Debugging, shows the direction and value
		if RaidRoll_DB["debug"] == true then RR_Test(direction) end
		if RaidRoll_DB["debug"] == true then RR_Test(RaidRoll_Loot_Slider:GetValue()) end
		
		--MOB_ID = RaidRoll_DB["Loot"][Current_Window]
		Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]
		
		if RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"] >= 4 then
			Loot_MaxNumber = RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"] - 3
		else
			Loot_MaxNumber = 1
		end
		
		RaidRoll_Loot_Slider:SetMinMaxValues(1, Loot_MaxNumber)
		
		
		RaidRoll_Loot_Slider:SetValue(RaidRoll_Loot_Slider:GetValue() - (direction * 2))
		
		if RaidRoll_Loot_Slider:GetValue() > Loot_MaxNumber then
			RaidRoll_Loot_Slider:SetValue(Loot_MaxNumber)
		end
		
		RR_ScrollOffset = RaidRoll_Loot_Slider:GetValue() - 1
	 
		RR_Loot_Display_Refresh()
	end
	
	if GetMouseFocus():GetName() == "RR_LootIcon1" or GetMouseFocus():GetName() == "RR_LootIcon2" or GetMouseFocus():GetName() == "RR_LootIcon3" or GetMouseFocus():GetName() == "RR_LootIcon4" then
		RR_MouseOver(GetMouseFocus():GetName())
	end
end


function RR_Loot_Display_Refresh()

Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]

	if RaidRoll_DB == nil then RaidRoll_DB = {} end
	if RaidRoll_DB["Loot"] == nil then RaidRoll_DB["Loot"] = {} end
	if RaidRoll_DB["Loot"][Current_Window] == nil then RaidRoll_DB["Loot"][Current_Window] = {} end
	if RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"] == nil then RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"] = 0 end

	if RaidRoll_DB["debug"] == true then 
		RR_Test("----RR_Loot_Display_Refresh 1----")
		RR_Test("Current_Window " .. Current_Window)
		RR_Test("TOTAL ITEMS " .. RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"])
	end

	if Current_Window ~= 0 then
	--Get the mob id for the current window
		--MOB_ID = RaidRoll_DB["Loot"][Current_Window]

		for i=1,4 do
			if i <= tonumber(RaidRoll_DB["Loot"][Current_Window]["TOTAL ITEMS"]) then
			--Get the slider offset
				j = i + RaidRoll_Loot_Slider:GetValue() - 1
				
				MobName		= RaidRoll_DB["Loot"][Current_Window]["MOB NAME"]
				LooterName	= RaidRoll_DB["Loot"][Current_Window]["LOOTER NAME"]
				
				ItemLink 	= RaidRoll_DB["Loot"][Current_Window]["ITEM_"..j]["ITEMLINK"]
				ItemIcon 	= RaidRoll_DB["Loot"][Current_Window]["ITEM_"..j]["ICON"]
				Winner 		= RaidRoll_DB["Loot"][Current_Window]["ITEM_"..j]["WINNER"]
				Received 	= RaidRoll_DB["Loot"][Current_Window]["ITEM_"..j]["RECEIVED"]
				
				
				if RaidRoll_DB["debug"] == true then 
					RR_Test("----RR_Loot_Display_Refresh----")
					RR_Test(MobName)
					RR_Test(LooterName)
					RR_Test(ItemLink)
					RR_Test(ItemIcon)
					RR_Test(Winner)
					RR_Test(Received)
				end
				
				
				_G["RR_Loot_Name_String"..i]:SetText(ItemLink)
				_G["RR_LootIcon"..i]:SetBackdrop( {bgFile = ItemIcon	})
				_G["RR_Loot_Won_String"..i]:SetText("Won Item: " .. Winner)
				_G["RR_Loot_Received_String"..i]:SetText("Received: " .. Received)
				
				RR_Loot_String_MobName:SetText("Mob Name: ".. MobName)
				RR_Loot_String_LooterName:SetText("Looter Name: ".. LooterName)
				
				RR_Loot_CurrentVsMaxWindow:SetText(RaidRoll_DB["Loot"]["CURRENT WINDOW"].."/"..RaidRoll_DB["Loot"]["TOTAL WINDOWS"])
			else
				_G["RR_Loot_Name_String"..i]:SetText("")
				_G["RR_LootIcon"..i]:SetBackdrop(rr_default_backdrop)
				_G["RR_Loot_Won_String"..i]:SetText("Won Item: ")
				_G["RR_Loot_Received_String"..i]:SetText("Received: ")
				
			end
		end
	end
end

function RR_MouseOver(ID)

	--RR_Test(ID)

	if ID == "RR_LootIcon1" then i = 1 end
	if ID == "RR_LootIcon2" then i = 2 end
	if ID == "RR_LootIcon3" then i = 3 end
	if ID == "RR_LootIcon4" then i = 4 end
	
	j = i + RaidRoll_Loot_Slider:GetValue() - 1

	Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]
	--MOB_ID = RaidRoll_DB["Loot"][Current_Window]

	GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
	GameTooltip:ClearAllPoints(); 
	GameTooltip:SetPoint("bottomleft", _G[ID], "topright", 0, 0)
	GameTooltip:ClearLines()
	
	if RaidRoll_DB["Loot"][Current_Window] ~= nil then
		if RaidRoll_DB["Loot"][Current_Window]["ITEM_"..j] ~= nil then
			GameTooltip:SetHyperlink(RaidRoll_DB["Loot"][Current_Window]["ITEM_"..j]["ITEMLINK"])
		end
	end
end 



function RR_Loot_WindowChangeSize(MinMax,TopBottom)

BottomLoc 	= RR_LOOT_FRAME:GetBottom();
xoff = RR_LOOT_FRAME:GetLeft()


	if RaidRoll_DB["debug"] == true then 
		RR_Test("-----")
		RR_Test(xoff)
		RR_Test(BottomLoc)

		RR_Test("-------")
		point, relativeTo, relativePoint, xOfs, yOfs = RR_LOOT_FRAME:GetPoint()
		RR_Test(point)
		RR_Test(relativeTo)
		RR_Test(relativePoint)
		RR_Test(xOfs)
		RR_Test(yOfs)
		RR_Test("---------")
	end




	if MinMax == "Min" then
		RR_Loot_ButtonMinMax:SetText("Max")
		RR_Loot_ButtonMinMax:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Max") end)
		RR_LOOT_FRAME:SetHeight(30)
		
		--RR_Loot_ButtonMinMaxTop:Hide()
		
		for i=1,4 do
			_G["RR_Loot_Name_String" .. i]:Hide()
			_G["RR_Loot_Won_String" .. i]:Hide() 
			_G["RR_Loot_Received_String" .. i]:Hide()
			_G["RR_LootIcon"..i]:Hide()
			
			RR_Loot_String_MobName:Hide()
			RR_Loot_String_LooterName:Hide()
			
			RR_Loot_ButtonFirst:Hide()
			RR_Loot_ButtonPrev:Hide()
			RR_Loot_ButtonNext:Hide()
			RR_Loot_ButtonLast:Hide()
			
			RaidRoll_Loot_Slider:Hide()
		end	
		
	end
	
	if MinMax == "Max" then
		RR_Loot_ButtonMinMax:SetText("Min")
		RR_Loot_ButtonMinMax:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Min") end)
		RR_LOOT_FRAME:SetHeight(270)
		
		--RR_Loot_ButtonMinMaxTop:Show()
		
		for i=1,4 do
			_G["RR_Loot_Name_String" .. i]:Show()
			_G["RR_Loot_Won_String" .. i]:Show() 
			_G["RR_Loot_Received_String" .. i]:Show()
			_G["RR_LootIcon"..i]:Show()
			
			RR_Loot_String_MobName:Show()
			RR_Loot_String_LooterName:Show()
			
			RR_Loot_ButtonFirst:Show()
			RR_Loot_ButtonPrev:Show()
			RR_Loot_ButtonNext:Show()
			RR_Loot_ButtonLast:Show()
			
			RaidRoll_Loot_Slider:Show()
		end	
		
	end
	
	if TopBottom == "Top" then
		RR_LOOT_FRAME:ClearAllPoints()
		RR_LOOT_FRAME:SetPoint("CENTER", nil, "topleft", xoff + (RR_LOOT_FRAME:GetWidth()/2),BottomLoc + (RR_LOOT_FRAME:GetHeight()/2))
	else
		RR_LOOT_FRAME:ClearAllPoints()
		RR_LOOT_FRAME:SetPoint("CENTER", nil, "bottomleft", xoff + (RR_LOOT_FRAME:GetWidth()/2),BottomLoc + (RR_LOOT_FRAME:GetHeight()/2))	
	end
	
	RR_LOOT_FRAME:ClearAllPoints()
	RR_LOOT_FRAME:SetPoint("CENTER", nil, "bottomleft", xoff + (RR_LOOT_FRAME:GetWidth()/2),BottomLoc + (RR_LOOT_FRAME:GetHeight()/2))
	
	
	
	
	


end 